unit formMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    procedure HandleIdle(Sender: TObject; var Done: boolean);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses
  messagepipe,
  testthread;

var
  fTestThread: TTestThread;


{$R *.dfm}

procedure TForm1.HandleIdle( Sender: TObject; var Done: boolean );
var
  aMessage: TMessage;
begin
  if fTestThread.OutPipe.Pull(aMessage) then begin
    Memo1.Lines.Add(aMessage.SomeString);
  end;
  Sleep(1);
  Done := True;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  aMessage: TMessage;
begin
  aMessage.SomeString := Edit1.Text;
  if not fTestThread.InPipe.Push(aMessage) then begin
    ShowMessage('Buffer Full');
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  fTestThread := TTestThread.Create;
  fTestThread.Resume;
  Memo1.Lines.Clear;
  Application.OnIdle := HandleIdle;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Application.OnIdle := nil;
  fTestThread.Terminate;
  fTestThread.WaitFor;
  fTestThread.DisposeOf;
end;

end.
