unit testthread;

interface
uses
  messagepipe,
  classes;

type
  TTestThread = class(TThread)
  private
    fInPipe: TMessagePipe;
    fOutPipe: TMessagePipe;
  public
    constructor Create; reintroduce;
    destructor Destroy; override;
    procedure Execute; override;
  public
    property InPipe: TMessagePipe read fInPipe;
    property OutPipe: TMessagePipe read fOutPipe;
  end;

implementation

{ TTestThread }

constructor TTestThread.Create;
begin
 inherited;
 fInPipe := TMessagePipe.Create;
 fOutPipe := TMessagePipe.Create;
end;

destructor TTestThread.Destroy;
begin
  fInPipe.DisposeOf;
  fOutPipe.DisposeOf;
  inherited;
end;

procedure TTestThread.Execute;
var
  aMessage: TMessage;
begin
  while not Terminated do begin
    Sleep(1);
    if fInPipe.Pull(aMessage) then begin
      fOutPipe.Push(aMessage);
    end;
  end;
end;

end.
